# Contributing to Siesta

Want to _do_ something instead of just talking about it? Fantastic! Be bold. Open a pull request.

## Code

- If you are proposing a design change or nontrivial new functionality, please **float your idea as an issue first** so you don’t end up doing wasted work.
- Please **follow the formatting conventions of the existing code**. Yes, that includes Paul’s idiosyncratic taste in brace placement:
  - Matching braces always go in either the same row or the same column, and
  - always align with the code they enclose.
- You will need to install [SwiftLint](https://github.com/realm/SwiftLint) to run the test target.
- Please make sure the tests pass locally (cmd-U in Xcode).
- Expect a little back and forth on your PR before it’s accepted. Don’t be discouraged by this. Questioning is not a sign you did bad work; on the contrary, it’s a sign of interest!

## Documentation

- No mistake is too small for a pull request — not even a one-character typo.
- If you have trouble building or testing the project, please submit an issue or PR about it — even if you resolve the problem. This will help improve the docs.
- If you want to update the user guide, note that the guide is generated from the `Docs` directory in `master`, so that’s where you should make your change. Do not submit pull requests against `gh-pages`.

Thank you for helping with Siesta!

P.S. Please be excellent to one another and follow our [code of conduct](https://github.com/bustoutsolutions/siesta/blob/master/CODE_OF_CONDUCT.md).
